; Module for pattern managing

(Comment "

Simple Patterns follow the following syntax:
variable
(pattern-expression arguments)

A pattern expression is in full control of its arguments,
but generally, this would consist in matching them          vvvvvvvvvvvvv

the pattern-expression is used to dispatch
the right constructor or destructor


   When inverting a no n-surjective pattern,
it is easy to raise an exception if the pattern is non-inversible:
however, when inverting a non-injective pattern,
what value should be given ?
Does the program mean that any matching value should be given,
and that the program should respect its specification whatever
value is given ?
That all values should be tried until one matches the rest of the program ?
   Now, if we allow any kind of non-determinism in inverted patterns,
we could as well allow the same kind of non-determinism among patterns.
   It seems to me that the semantically correct way of doing things,
is that a match operation should indeterministically return any matching
term if possible; but because the match pattern need not be linear,
solving indeterminacies cannot be done in a local way, and sometimes,
no computable mechanism can even solve them; thus, reflective escape to
tactics that control this unification are needed.
   Anyway, let us first focus on simple patterns, and pattern language...


; arguments:
;

; Creating patterns:
(pattern (pattern-name

")



(define (occurs? u v)
   (and
    ((occurs?
    
      (lambda (u v)
	(and (pair? v)
	     (define (f l)
		(and (not (null? l))
		     (or (eq? u (car l))
			 (occurs? u (car l))
			 (f (cdr l)))))
	     (f (cdr v)))))
     (sigma
      (lambda (u v s)
	(lambda (x)
	  (define (f x)
	    (if (symbol? x)
		(if (eq? x u) v x)
		(cons (car x) (map f (cdr x)))))
	  (f (s x)))))
     (try-subst
      (lambda (u v s ks kf)
	(let ((u (s u)))
	  (if (not (symbol? u))
	      (uni u v s ks kf)
	      (let ((v (s v)))
		(cond
		 ((eq? u v) (ks s))
		 ((occurs? u v) (kf "loop"))
		 (else (ks (sigma u v s)))))))))
     (uni
      (lambda (u v s ks kf)
	(cond
	 ((symbol? u) (try-subst u v s ks kf))
	 ((symbol? v) (try-subst v u s ks kf))
	 ((and (eq? (car u) (car v))
	       (= (length u) (length v)))
	  (define (f u v s)
	    (if (null? u)
		(ks s)
		(uni (car u)
		     (car v)
		     s
		     (lambda (s) (f (cdr u) (cdr v) s))
		     kf)))
	  (f (cdr u) (cdr v) s))
	  (else (kf "clash"))))))
     (set! unify
	   (lambda (u v)
	     (uni u
		  v
		  (lambda (x) x)
		  (lambda (s) (s u))
		  (lambda (msg) msg)))))
		
(print (unify 'x 'y))
(print (unify '(f x y) '(g x y)))
(print (unify '(f x (h)) '(f (h) y)))
(print (unify '(f (g x) y) '(f y x)))
(print (unify '(f (g x) y) '(f y (g x))))



(define-pattern cons
   (lambda->pattern
      (lambda (x y) ((using scheme cons) x y))
      (lambda ((scheme-object z))
         (if (pair? z) (return (car z) (cdr z)) (fail-match)))))

(define-pattern conscons
   (symmetric-pattern (x y z)
      (cons x (cons y z)))

(define-pattern (<< n
  (Object (Type: pattern)
  	  (cons: (lambda ((integer x) (positive-integer y))
	            ((using scheme-support <<) x y)))
	  (des:  (lambda ((integer z))
	            (and-not ((using scheme-support <<) -1


(lambda (x y z) (list z x y))

(match (x y z)



